#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>

#define MAXDIM 100
typedef int MATRICA[MAXDIM][MAXDIM];

//void prikazMatrice(int matrica[][100], int n, int m);//prototip funkcije
void prikazMatrice(MATRICA matrica, int n, int m);//prototip funkcije
void unosMatrice(MATRICA matrica, int *n, int *m);
void redSaNajvecomSumom(MATRICA matrica, int n, int m);
void kolonaSaNajvecomSumom(MATRICA matrica, int n, int m);
int sumaZadateKolone(MATRICA matrica, int n, int kolona);
void kolonaSaNajvecomSumomBoljiNacin(MATRICA matrica, int n, int m);
void prikazGlavneDijagonale(MATRICA matrica, int n);
void prikazSporedneDijagonaleMatrice(MATRICA matrica, int n);
void formirajNizOdSporedneDijagonaleMatrice(MATRICA matrica, int n, int niz[], int *brel);
int daLiPostojiZadatiElementUNizu(int niz[], int n, int broj);
void prikazNiza(int niz[], int n);

int main(void) {
	//int matrica[10][10];
	//int matrica[][3] = { {3,2,1}, {4,3,2}, {5,4,3}, {6,5,4} };
	//int matrica[10][10] = { {3,2,1}, {4,3,2}, {5,4,3}, {6,5,4} };
	
	MATRICA matrica = { 
		{3,23,1,2}, 
		{4,3,2,3}, 
		{5,4,3,4}, 
		{6,5,4,5} 
	};
	int n = 4;
	int m = 4;

	int niz[MAXDIM];
	int brel = 0;

	/*
	MATRICA matrica;
	int n;
	int m;
	*/

	//unosMatrice(matrica, &n, &m);
	prikazMatrice(matrica, n, m);

	redSaNajvecomSumom(matrica, n, m);
	kolonaSaNajvecomSumom(matrica, n, m);

	prikazGlavneDijagonale(matrica, n);
	prikazSporedneDijagonaleMatrice(matrica, n);
	formirajNizOdSporedneDijagonaleMatrice(matrica, n, niz, &brel);
	prikazNiza(niz, brel);

	system("pause");
	return 0;
}

/*
void prikazMatrice(int matrica[][100], int n, int m) {

}
*/
void prikazMatrice(MATRICA matrica, int n, int m) {
	int i;
	int j;
	printf("Elementi matrice su:\n");
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {
			printf("%d\t", matrica[i][j]);
		}
		printf("\n");
	}
}

void unosMatrice(MATRICA matrica, int *n, int *m) {
	int i;
	int j;
	printf("Unesite dimenziju matrice u formatu nxm\n");
	scanf("%dx%d", n, m);

	printf("Unesite elemente matrice:\n");
	for (i = 0; i < *n; i++) {
		for (j = 0; j < *m; j++) {
			printf("Unesite elemnt [%d, %d]\n", i+1, j+1);
			scanf("%d", &matrica[i][j]);
		}
	}
}

void redSaNajvecomSumom(MATRICA matrica, int n, int m) {
	int i;
	int j;
	int maxSuma = 0;
	int suma=0;
	int maxIndeks;
	for (i = 0; i < n; i++) {
		suma = 0;
		for (j = 0; j < m; j++) {
			suma = suma + matrica[i][j];
		}
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndeks = i;
		}
	}
	printf("Indeks reda sa maksimalnom sumom je %d\n", maxIndeks);
}

void kolonaSaNajvecomSumom(MATRICA matrica, int n, int m) {
	int i;
	int j;
	int maxSuma = 0;
	int suma = 0;
	int maxIndeks;
	for (j = 0; j < m; j++) {
		suma = 0;
		for (i = 0; i < n; i++) {
			suma = suma + matrica[i][j];
		}
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndeks = j;
		}
	}
	printf("Indeks kolone sa maksimalnom sumom je %d\n", maxIndeks);
}

int sumaZadateKolone(MATRICA matrica, int n, int kolona) {
	int i;
	int suma = 0;
	for (i = 0; i < n; i++) {
		suma = suma + matrica[i][kolona];
	}
	return suma;

}

void kolonaSaNajvecomSumomBoljiNacin(MATRICA matrica, int n, int m) {
	int j;
	int maxSuma = sumaZadateKolone(matrica,n,0);
	int maxIndeks;
	int suma;
	for (j = 1; j < m; j++) {
		suma = sumaZadateKolone(matrica, n, j);
		if (suma > maxSuma) {
			maxSuma = suma;
			maxIndeks = j;
		}
	}
	printf("Indeks kolone sa maksimalnom sumom je %d\n", maxIndeks);
}

void prikazGlavneDijagonale(MATRICA matrica, int n) {
	/*int i;
	int j;
	printf("Elementi na glavnoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		for (j = 0; j < n; j++) {
			if (i == j) {
				printf("%d\t", matrica[i][j]);
			}
		}
	}
	printf("\n");*/

	int i;
	printf("Elementi na glavnoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		printf("%d\t", matrica[i][i]);
	}
	printf("\n");
}

void prikazSporedneDijagonaleMatrice(MATRICA matrica, int n) {
	int i;
	printf("Elementi na sporednoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		printf("%d\t", matrica[i][n-1-i]);
	}
	printf("\n");
}

void formirajNizOdSporedneDijagonaleMatrice(MATRICA matrica, int n, int niz[], int *brel) {
	int i;
	printf("Elementi na sporednoj dijagonali matrice su:\n");
	for (i = 0; i < n; i++) {
		if (daLiPostojiZadatiElementUNizu(niz, *brel, matrica[i][n - 1 - i]) == 0) {
			niz[*brel] = matrica[i][n - 1 - i];
			*brel = *brel + 1;
		}
	}
}

int daLiPostojiZadatiElementUNizu(int niz[], int n, int broj) {
	int i;
	int postoji = 0;//ne postioji
	for (i = 0; i < n; i++) {
		if (niz[i] == broj) {
			postoji = 1;
			break;
		}
	}
	return postoji;
}

void prikazNiza(int niz[], int n) {
	int i;
	printf("Elementi niza su:\n");
	for (i = 0; i < n; i++) {
		printf("%d\t", niz[i]);
	}
	printf("\n");
}